testdraw2.c File Reference
`#include <stdlib.h>`
`#include <stdio.h>`
`#include <time.h>`
`#include "SDL_test_common.h"`
Include dependency graph for testdraw2.c:

Go to the source code of this file.

## Macros

#define | NUM_OBJECTS 100

## Functions

void | DrawPoints (SDL_Renderer *renderer)
void | DrawLines (SDL_Renderer *renderer)
void | DrawRects (SDL_Renderer *renderer)
void | loop ()
int | main (int argc, char *argv[])

## Variables

static SDLTest_CommonState * | state
static int | num_objects
static SDL_bool | cycle_color
static SDL_bool | cycle_alpha
static int | cycle_direction = 1
static int | current_alpha = 255
static int | current_color = 255
static SDL_BlendMode | blendMode = SDL_BLENDMODE_NONE
int | done

## Macro Definition Documentation

## NUM_OBJECTS

#define NUM_OBJECTS 100

Definition at line 25 of file testdraw2.c.

Referenced by main().

## Function Documentation

## DrawLines()

void DrawLines | ( | SDL_Renderer * | renderer | ) |

Definition at line 82 of file testdraw2.c.

References current_alpha, current_color, cycle_alpha, cycle_color, cycle_direction, SDL_Rect::h, i, num_objects, SDL_RenderDrawLine, SDL_RenderGetViewport, SDL_SetRenderDrawColor, viewport, and SDL_Rect::w.

Referenced by loop().

{
int i;
int x1, y1, x2, y2;
SDL_Rect viewport;
/* Query the sizes */
SDL_RenderGetViewport(renderer, &viewport);
for (i = 0; i < num_objects; ++i) {
/* Cycle the color and alpha, if desired */
if (cycle_color) {
current_color += cycle_direction;
if (current_color < 0) {
current_color = 0;
cycle_direction = -cycle_direction;
}
if (current_color > 255) {
current_color = 255;
cycle_direction = -cycle_direction;
}
}
if (cycle_alpha) {
current_alpha += cycle_direction;
if (current_alpha < 0) {
current_alpha = 0;
cycle_direction = -cycle_direction;
}
if (current_alpha > 255) {
current_alpha = 255;
cycle_direction = -cycle_direction;
}
}
SDL_SetRenderDrawColor(renderer, 255, (Uint8) current_color,
(Uint8) current_color, (Uint8) current_alpha);
if (i == 0) {
SDL_RenderDrawLine(renderer, 0, 0, viewport.w - 1, viewport.h - 1);
SDL_RenderDrawLine(renderer, 0, viewport.h - 1, viewport.w - 1, 0);
SDL_RenderDrawLine(renderer, 0, viewport.h / 2, viewport.w - 1, viewport.h / 2);
SDL_RenderDrawLine(renderer, viewport.w / 2, 0, viewport.w / 2, viewport.h - 1);
} else {
x1 = (rand() % (viewport.w*2)) - viewport.w;
x2 = (rand() % (viewport.w*2)) - viewport.w;
y1 = (rand() % (viewport.h*2)) - viewport.h;
y2 = (rand() % (viewport.h*2)) - viewport.h;
SDL_RenderDrawLine(renderer, x1, y1, x2, y2);
}
}
}
x1
GLuint GLfloat GLfloat GLfloat x1
Definition: SDL_opengl_glext.h:8583
y2
GLfixed GLfixed GLfixed y2
Definition: SDL_opengl_glext.h:4583
x2
GLfixed GLfixed x2
Definition: SDL_opengl_glext.h:4583
cycle_color
static SDL_bool cycle_color
Definition: testdraw2.c:29
y1
GLfixed y1
Definition: SDL_opengl_glext.h:4583
current_alpha
static int current_alpha
Definition: testdraw2.c:32
num_objects
static int num_objects
Definition: testdraw2.c:28
current_color
static int current_color
Definition: testdraw2.c:33
Uint8
uint8_t Uint8
Definition: SDL_stdinc.h:157
SDL_RenderGetViewport
#define SDL_RenderGetViewport
Definition: SDL_dynapi_overrides.h:325
SDL_Rect::w
int w
Definition: SDL_rect.h:67
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:50
cycle_alpha
static SDL_bool cycle_alpha
Definition: testdraw2.c:30
SDL_Rect::h
int h
Definition: SDL_rect.h:67
viewport
SDL_Rect viewport
Definition: testviewport.c:28
SDL_SetRenderDrawColor
#define SDL_SetRenderDrawColor
Definition: SDL_dynapi_overrides.h:330
cycle_direction
static int cycle_direction
Definition: testdraw2.c:31
SDL_RenderDrawLine
#define SDL_RenderDrawLine
Definition: SDL_dynapi_overrides.h:337
SDL_Rect
A rectangle, with the origin at the upper left.
Definition: SDL_rect.h:64

## DrawPoints()

void DrawPoints | ( | SDL_Renderer * | renderer | ) |

Definition at line 39 of file testdraw2.c.

References current_alpha, current_color, cycle_alpha, cycle_color, cycle_direction, SDL_Rect::h, i, num_objects, SDL_RenderDrawPoint, SDL_RenderGetViewport, SDL_SetRenderDrawColor, viewport, and SDL_Rect::w.

Referenced by loop().

{
int i;
int x, y;
SDL_Rect viewport;
/* Query the sizes */
SDL_RenderGetViewport(renderer, &viewport);
for (i = 0; i < num_objects * 4; ++i) {
/* Cycle the color and alpha, if desired */
if (cycle_color) {
current_color += cycle_direction;
if (current_color < 0) {
current_color = 0;
cycle_direction = -cycle_direction;
}
if (current_color > 255) {
current_color = 255;
cycle_direction = -cycle_direction;
}
}
if (cycle_alpha) {
current_alpha += cycle_direction;
if (current_alpha < 0) {
current_alpha = 0;
cycle_direction = -cycle_direction;
}
if (current_alpha > 255) {
current_alpha = 255;
cycle_direction = -cycle_direction;
}
}
SDL_SetRenderDrawColor(renderer, 255, (Uint8) current_color,
(Uint8) current_color, (Uint8) current_alpha);
x = rand() % viewport.w;
y = rand() % viewport.h;
SDL_RenderDrawPoint(renderer, x, y);
}
}
SDL_RenderDrawPoint
#define SDL_RenderDrawPoint
Definition: SDL_dynapi_overrides.h:335
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1574
cycle_color
static SDL_bool cycle_color
Definition: testdraw2.c:29
current_alpha
static int current_alpha
Definition: testdraw2.c:32
num_objects
static int num_objects
Definition: testdraw2.c:28
current_color
static int current_color
Definition: testdraw2.c:33
Uint8
uint8_t Uint8
Definition: SDL_stdinc.h:157
SDL_RenderGetViewport
#define SDL_RenderGetViewport
Definition: SDL_dynapi_overrides.h:325
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1574
SDL_Rect::w
int w
Definition: SDL_rect.h:67
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:50
cycle_alpha
static SDL_bool cycle_alpha
Definition: testdraw2.c:30
SDL_Rect::h
int h
Definition: SDL_rect.h:67
viewport
SDL_Rect viewport
Definition: testviewport.c:28
SDL_SetRenderDrawColor
#define SDL_SetRenderDrawColor
Definition: SDL_dynapi_overrides.h:330
cycle_direction
static int cycle_direction
Definition: testdraw2.c:31
SDL_Rect
A rectangle, with the origin at the upper left.
Definition: SDL_rect.h:64

## DrawRects()

void DrawRects | ( | SDL_Renderer * | renderer | ) |

Definition at line 134 of file testdraw2.c.

References current_alpha, current_color, cycle_alpha, cycle_color, cycle_direction, SDL_Rect::h, i, num_objects, rect, SDL_RenderFillRect, SDL_RenderGetViewport, SDL_SetRenderDrawColor, viewport, SDL_Rect::w, SDL_Rect::x, and SDL_Rect::y.

Referenced by loop().

{
int i;
SDL_Rect rect;
SDL_Rect viewport;
/* Query the sizes */
SDL_RenderGetViewport(renderer, &viewport);
for (i = 0; i < num_objects / 4; ++i) {
/* Cycle the color and alpha, if desired */
if (cycle_color) {
current_color += cycle_direction;
if (current_color < 0) {
current_color = 0;
cycle_direction = -cycle_direction;
}
if (current_color > 255) {
current_color = 255;
cycle_direction = -cycle_direction;
}
}
if (cycle_alpha) {
current_alpha += cycle_direction;
if (current_alpha < 0) {
current_alpha = 0;
cycle_direction = -cycle_direction;
}
if (current_alpha > 255) {
current_alpha = 255;
cycle_direction = -cycle_direction;
}
}
SDL_SetRenderDrawColor(renderer, 255, (Uint8) current_color,
(Uint8) current_color, (Uint8) current_alpha);
rect.w = rand() % (viewport.h / 2);
rect.h = rand() % (viewport.h / 2);
rect.x = (rand() % (viewport.w*2) - viewport.w) - (rect.w / 2);
rect.y = (rand() % (viewport.h*2) - viewport.h) - (rect.h / 2);
SDL_RenderFillRect(renderer, &rect);
}
}
rect
SDL_Rect rect
Definition: testrelative.c:27
SDL_RenderFillRect
#define SDL_RenderFillRect
Definition: SDL_dynapi_overrides.h:341
cycle_color
static SDL_bool cycle_color
Definition: testdraw2.c:29
current_alpha
static int current_alpha
Definition: testdraw2.c:32
num_objects
static int num_objects
Definition: testdraw2.c:28
current_color
static int current_color
Definition: testdraw2.c:33
Uint8
uint8_t Uint8
Definition: SDL_stdinc.h:157
SDL_RenderGetViewport
#define SDL_RenderGetViewport
Definition: SDL_dynapi_overrides.h:325
SDL_Rect::x
int x
Definition: SDL_rect.h:66
SDL_Rect::w
int w
Definition: SDL_rect.h:67
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:50
cycle_alpha
static SDL_bool cycle_alpha
Definition: testdraw2.c:30
SDL_Rect::h
int h
Definition: SDL_rect.h:67
viewport
SDL_Rect viewport
Definition: testviewport.c:28
SDL_SetRenderDrawColor
#define SDL_SetRenderDrawColor
Definition: SDL_dynapi_overrides.h:330
cycle_direction
static int cycle_direction
Definition: testdraw2.c:31
SDL_Rect::y
int y
Definition: SDL_rect.h:66
SDL_Rect
A rectangle, with the origin at the upper left.
Definition: SDL_rect.h:64

## loop()

void loop | ( |  | ) |

Definition at line 179 of file testdraw2.c.

References done, DrawLines(), DrawPoints(), DrawRects(), i, NULL, SDLTest_CommonState::num_windows, renderer, SDLTest_CommonState::renderers, SDL_PollEvent, SDL_RenderClear, SDL_RenderPresent, SDL_SetRenderDrawColor, SDLTest_CommonEvent(), and SDLTest_CommonState::windows.

Referenced by main().

{
int i;
SDL_Event event;
/* Check for events */
while (SDL_PollEvent(&event)) {
SDLTest_CommonEvent(state, &event, &done);
}
for (i = 0; i < state->num_windows; ++i) {
SDL_Renderer *renderer = state->renderers[i];
if (state->windows[i] == NULL)
continue;
SDL_SetRenderDrawColor(renderer, 0xA0, 0xA0, 0xA0, 0xFF);
SDL_RenderClear(renderer);
DrawRects(renderer);
DrawLines(renderer);
DrawPoints(renderer);
SDL_RenderPresent(renderer);
}
#ifdef __EMSCRIPTEN__
if (done) {
emscripten_cancel_main_loop();
}
#endif
}
state
static SDLTest_CommonState * state
Definition: testdraw2.c:27
SDL_PollEvent
#define SDL_PollEvent
Definition: SDL_dynapi_overrides.h:122
SDL_Renderer
Definition: SDL_sysrender.h:76
SDLTest_CommonState::windows
SDL_Window ** windows
Definition: SDL_test_common.h:78
SDLTest_CommonState::num_windows
int num_windows
Definition: SDL_test_common.h:77
SDLTest_CommonEvent
void SDLTest_CommonEvent(SDLTest_CommonState *state, SDL_Event *event, int *done)
Common event handler for test windows.
Definition: SDL_test_common.c:1425
renderer
static SDL_Renderer * renderer
Definition: testaudiocapture.c:21
event
struct _cl_event * event
Definition: SDL_opengl_glext.h:2649
DrawLines
void DrawLines(SDL_Renderer *renderer)
Definition: testdraw2.c:82
done
int done
Definition: testdraw2.c:36
SDLTest_CommonState::renderers
SDL_Renderer ** renderers
Definition: SDL_test_common.h:84
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:50
NULL
#define NULL
Definition: begin_code.h:164
SDL_RenderClear
#define SDL_RenderClear
Definition: SDL_dynapi_overrides.h:334
DrawPoints
void DrawPoints(SDL_Renderer *renderer)
Definition: testdraw2.c:39
SDL_Event
General event structure.
Definition: SDL_events.h:525
SDL_SetRenderDrawColor
#define SDL_SetRenderDrawColor
Definition: SDL_dynapi_overrides.h:330
DrawRects
void DrawRects(SDL_Renderer *renderer)
Definition: testdraw2.c:134
SDL_RenderPresent
#define SDL_RenderPresent
Definition: SDL_dynapi_overrides.h:346

## main()

int main | ( | int | argc,
|  | char * | argv[]
| ) |  |

Definition at line 209 of file testdraw2.c.

References blendMode, cycle_alpha, cycle_color, done, i, loop(), NULL, NUM_OBJECTS, num_objects, SDLTest_CommonState::num_windows, renderer, SDLTest_CommonState::renderers, SDL_atoi, SDL_BLENDMODE_ADD, SDL_BLENDMODE_BLEND, SDL_BLENDMODE_MOD, SDL_BLENDMODE_NONE, SDL_GetTicks(), SDL_INIT_VIDEO, SDL_isdigit, SDL_Log, SDL_LOG_CATEGORY_APPLICATION, SDL_LOG_PRIORITY_INFO, SDL_LogSetPriority, SDL_RenderClear, SDL_SetRenderDrawBlendMode, SDL_SetRenderDrawColor, SDL_strcasecmp, SDL_TRUE, SDLTest_CommonArg(), SDLTest_CommonCreateState(), SDLTest_CommonInit(), SDLTest_CommonQuit(), and SDLTest_CommonUsage().

{
int i;
Uint32 then, now, frames;
/* Enable standard application logging */
SDL_LogSetPriority(SDL_LOG_CATEGORY_APPLICATION, SDL_LOG_PRIORITY_INFO);
/* Initialize parameters */
num_objects = NUM_OBJECTS;
/* Initialize test framework */
state = SDLTest_CommonCreateState(argv, SDL_INIT_VIDEO);
if (!state) {
return 1;
}
for (i = 1; i < argc;) {
int consumed;
consumed = SDLTest_CommonArg(state, i);
if (consumed == 0) {
consumed = -1;
if (SDL_strcasecmp(argv[i], "--blend") == 0) {
if (argv[i + 1]) {
if (SDL_strcasecmp(argv[i + 1], "none") == 0) {
blendMode = SDL_BLENDMODE_NONE;
consumed = 2;
} else if (SDL_strcasecmp(argv[i + 1], "blend") == 0) {
blendMode = SDL_BLENDMODE_BLEND;
consumed = 2;
} else if (SDL_strcasecmp(argv[i + 1], "add") == 0) {
blendMode = SDL_BLENDMODE_ADD;
consumed = 2;
} else if (SDL_strcasecmp(argv[i + 1], "mod") == 0) {
blendMode = SDL_BLENDMODE_MOD;
consumed = 2;
}
}
} else if (SDL_strcasecmp(argv[i], "--cyclecolor") == 0) {
cycle_color = SDL_TRUE;
consumed = 1;
} else if (SDL_strcasecmp(argv[i], "--cyclealpha") == 0) {
cycle_alpha = SDL_TRUE;
consumed = 1;
} else if (SDL_isdigit(*argv[i])) {
num_objects = SDL_atoi(argv[i]);
consumed = 1;
}
}
if (consumed < 0) {
SDL_Log("Usage: %s %s [--blend none|blend|add|mod] [--cyclecolor] [--cyclealpha]\n",
argv[0], SDLTest_CommonUsage(state));
return 1;
}
i += consumed;
}
if (!SDLTest_CommonInit(state)) {
return 2;
}
/* Create the windows and initialize the renderers */
for (i = 0; i < state->num_windows; ++i) {
SDL_Renderer *renderer = state->renderers[i];
SDL_SetRenderDrawBlendMode(renderer, blendMode);
SDL_SetRenderDrawColor(renderer, 0xA0, 0xA0, 0xA0, 0xFF);
SDL_RenderClear(renderer);
}
srand((unsigned int)time(NULL));
/* Main render loop */
frames = 0;
then = SDL_GetTicks();
done = 0;
#ifdef __EMSCRIPTEN__
emscripten_set_main_loop(loop, 0, 1);
#else
while (!done) {
++frames;
loop();
}
#endif
SDLTest_CommonQuit(state);
/* Print out some timing information */
now = SDL_GetTicks();
if (now > then) {
double fps = ((double) frames * 1000) / (now - then);
SDL_Log("%2.2f frames per second\n", fps);
}
return 0;
}
state
static SDLTest_CommonState * state
Definition: testdraw2.c:27
NUM_OBJECTS
#define NUM_OBJECTS
Definition: testdraw2.c:25
SDL_TRUE
Definition: SDL_stdinc.h:142
time
EGLSurface EGLnsecsANDROID time
Definition: eglext.h:518
SDL_BLENDMODE_NONE
Definition: SDL_blendmode.h:42
SDLTest_CommonCreateState
SDLTest_CommonState * SDLTest_CommonCreateState(char **argv, Uint32 flags)
Parse command line parameters and create common state.
Definition: SDL_test_common.c:48
SDLTest_CommonArg
int SDLTest_CommonArg(SDLTest_CommonState *state, int index)
Process one common argument.
Definition: SDL_test_common.c:106
SDL_SetRenderDrawBlendMode
#define SDL_SetRenderDrawBlendMode
Definition: SDL_dynapi_overrides.h:332
SDL_Renderer
Definition: SDL_sysrender.h:76
Uint32
uint32_t Uint32
Definition: SDL_stdinc.h:181
SDL_strcasecmp
#define SDL_strcasecmp
Definition: SDL_dynapi_overrides.h:419
loop
void loop()
Definition: testdraw2.c:179
SDLTest_CommonInit
SDL_bool SDLTest_CommonInit(SDLTest_CommonState *state)
Open test window.
Definition: SDL_test_common.c:726
cycle_color
static SDL_bool cycle_color
Definition: testdraw2.c:29
SDL_BLENDMODE_MOD
Definition: SDL_blendmode.h:50
blendMode
static SDL_BlendMode blendMode
Definition: testdraw2.c:34
SDLTest_CommonState::num_windows
int num_windows
Definition: SDL_test_common.h:77
SDL_Log
#define SDL_Log
Definition: SDL_dynapi_overrides.h:31
num_objects
static int num_objects
Definition: testdraw2.c:28
SDL_isdigit
#define SDL_isdigit
Definition: SDL_dynapi_overrides.h:382
SDL_GetTicks
Uint32 SDL_GetTicks(void)
Get the number of milliseconds since the SDL library initialization.
renderer
static SDL_Renderer * renderer
Definition: testaudiocapture.c:21
done
int done
Definition: testdraw2.c:36
SDL_LOG_PRIORITY_INFO
Definition: SDL_log.h:106
SDLTest_CommonUsage
const char * SDLTest_CommonUsage(SDLTest_CommonState *state)
Returns common usage information.
Definition: SDL_test_common.c:478
SDL_atoi
#define SDL_atoi
Definition: SDL_dynapi_overrides.h:410
SDLTest_CommonState::renderers
SDL_Renderer ** renderers
Definition: SDL_test_common.h:84
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:50
SDL_LogSetPriority
#define SDL_LogSetPriority
Definition: SDL_dynapi_overrides.h:236
NULL
#define NULL
Definition: begin_code.h:164
cycle_alpha
static SDL_bool cycle_alpha
Definition: testdraw2.c:30
SDL_RenderClear
#define SDL_RenderClear
Definition: SDL_dynapi_overrides.h:334
SDL_BLENDMODE_ADD
Definition: SDL_blendmode.h:47
SDL_SetRenderDrawColor
#define SDL_SetRenderDrawColor
Definition: SDL_dynapi_overrides.h:330
SDL_LOG_CATEGORY_APPLICATION
Definition: SDL_log.h:66
SDLTest_CommonQuit
void SDLTest_CommonQuit(SDLTest_CommonState *state)
Close test window.
Definition: SDL_test_common.c:1751
SDL_INIT_VIDEO
#define SDL_INIT_VIDEO
Definition: SDL.h:78
SDL_BLENDMODE_BLEND
Definition: SDL_blendmode.h:44

## Variable Documentation

## blendMode

SDL_BlendMode blendMode = SDL_BLENDMODE_NONE

static

Definition at line 34 of file testdraw2.c.

Referenced by _surfaceSetUp(), main(), SDL_BlendFillRects(), SDL_BlendPoints(), SDL_ComposeCustomBlendMode(), SDL_CreateTextureFromSurface(), SDL_GetLongBlendMode(), SDL_GetShortBlendMode(), SDL_SetRenderDrawBlendMode(), and SDL_SetTextureBlendMode().

## current_alpha

int current_alpha = 255

static

Definition at line 32 of file testdraw2.c.

Referenced by DrawLines(), DrawPoints(), and DrawRects().

## current_color

int current_color = 255

static

Definition at line 33 of file testdraw2.c.

Referenced by DrawLines(), DrawPoints(), and DrawRects().

## cycle_alpha

SDL_bool cycle_alpha

static

Definition at line 30 of file testdraw2.c.

Referenced by DrawLines(), DrawPoints(), DrawRects(), and main().

## cycle_color

SDL_bool cycle_color

static

Definition at line 29 of file testdraw2.c.

Referenced by DrawLines(), DrawPoints(), DrawRects(), and main().

## cycle_direction

int cycle_direction = 1

static

Definition at line 31 of file testdraw2.c.

Referenced by DrawLines(), DrawPoints(), and DrawRects().

## done

int done

Definition at line 36 of file testdraw2.c.

Referenced by loop(), and main().

## num_objects

int num_objects

static

Definition at line 28 of file testdraw2.c.

Referenced by DrawLines(), DrawPoints(), DrawRects(), and main().

## state

SDLTest_CommonState* state

static

Definition at line 27 of file testdraw2.c.